%define name dixi-main
%define rversion 0.3.20
%define release %mkrel 2

%define dixidir %{_datadir}/dixi
%define xosdstagesdir %{_sysconfdir}/xos/config/xosd_stages
%define xosconfigdir %{_sysconfdir}/xos/config

Summary: Distributed XtreemOS Infrastructure
Name: %{name}
Version: %{rversion}
Release: %{release}
Source0: %{name}-%{rversion}.tar.bz2
Source1: axis2-kernel-1.2.jar
Source2: mina-core-1.1.5.jar
Source3: mina-filter-ssl-1.1.5.jar
Source4: velocity-dep-1.5.jar
Source5: slf4j-api-1.5.0.jar
Source6: slf4j-simple-1.5.0.jar
#Source7: log4j-over-slf4j-1.5.0.jar
Source8: exist.jar
Source9: vivaldi-1.1.jar
Source10: cloning-1.4.jar
Source11: axis2-kernel-1.3.jar
Source12: objenesis-1.1.jar
Source23: xmlrpc-server-3.1.2.jar
Source24: xmlrpc-common-3.1.2.jar
Source25: xmlrpc-client-3.1.2.jar

# the way to grab the sources is as follows:
# cvs -z3 -d:pserver:anonymous@xmldb-org.cvs.sourceforge.net:/cvsroot/xmldb-org co -P xapi
# Sources of xmldb.jar reside under xapi/src/api.
# (thanks to Ales Cernivec for the info)
Source13: xmldb-svn.jar

License: GPL
Group: System/Cluster
Url: http://xtreemos.eu/
BuildRoot: %{_tmppath}/%{name}-%{rversion}-%{release}-buildroot
BuildRequires: xos-devel xos-blcr-devel pam-devel
Buildrequires: libxml2-devel ant ant-nodeps
BuildRequires: java-devel jpackage-utils jgroups
BuildRequires: xstream allocation-mng jug srds velocity
BuildRequires: log4j velocity testng easymock2 jmock1 hamcrest bouncycastle sunxacml
BuildRequires: srds
Requires: log4j velocity testng easymock2 jmock1 hamcrest bouncycastle sunxacml
Requires: jpackage-utils jgroups
Requires: xstream jug
Requires: allocation-mng
Requires: srds
Requires: %{name}-jardeps = %{version}

%description
 * DIXI (DIstributed Xtreemos Infrastructure):
   * service code generation tools,
   * staging and communication daemons for running services,
 * AEM services (WP3.3 software)
 * certain VOM services (WP3.5 software):
   * VOPS,
   * RCA,
   * CDAMng (access interface for the CDA from DIXI).

%package -n dixi-services
Group: System/Cluster
Summary: Dixi main services
%description -n dixi-services
This package provides the classes implementing the main services, needed
by other services.

%package -n dixi-xati
Group: System/Cluster
Summary: Collection of API and client-side access points for running clients
%description -n dixi-xati
XATI, the collection of API and client-side access points for running
clients. It also contains sample client programs and scripts for running
them.

%package -n dixi-cxati
Group: System/Cluster
Summary: Access point and API for programs written in C
%description -n dixi-cxati
This package is similar to XATI, except that it provides the access
point and API for programs written in C.

%package -n dixi-devel
Group: System/Cluster
Summary: Developement files for dixi
%description -n dixi-devel
Developement files for dixi.

%package -n dixi-core
Group: System/Cluster
Summary: Virtual package for dixi core services
Requires: dixi-main, dixi-services, dixi-xati, dixi-cxati
%description -n dixi-core
Virtual package for dixi core services

%package -n dixi-node
Group: System/Cluster
Summary: Virtual package for dixi node
Requires: dixi-main, dixi-services, dixi-xati, dixi-cxati
%description -n dixi-node
Virtual package for dixi node

%package -n dixi-client
Group: System/Cluster
Summary: Virtual package for dixi client
Requires: dixi-main, dixi-services, dixi-xati, dixi-cxati
%description -n dixi-client
Virtual package for dixi client

%package jardeps
Group: System/Cluster
Summary: Jar dependencies for dixi-main

%description jardeps
Jar dependencies for dixi-main

%package javadoc
Group: System/Cluster
Summary: Dixi javadoc

%description javadoc
DIXI javadoc

%prep
%setup -q

%build
ant -DJARDepsDir=/usr/share/java -lib %{SOURCE8}:%{SOURCE9}:%{SOURCE10}:%{SOURCE11}:%{_javadir}/bcprov.jar:%{_javadir}/junit4.jar build-java
ant -DJARDepsDir=/usr/share/java -lib %{SOURCE8}:%{SOURCE9}:%{SOURCE10}:%{SOURCE11}:%{_javadir}/bcprov.jar:%{_javadir}/junit4.jar build-c

%install
rm -rf $RPM_BUILD_ROOT
%{__mkdir_p} %{buildroot}%{_javadir}
%{__mkdir_p} %{buildroot}%{dixidir}
%{__mkdir_p} %{buildroot}%{_libdir}
%{__mkdir_p} %{buildroot}%{_sysconfdir}
%{__mkdir_p} %{buildroot}%{_sysconfdir}/xos/truststore/certs/incoming
%{__mkdir_p} %{buildroot}%{_sysconfdir}/xos/truststore/private

mkdir Support/libs

ant -DDEST=%{buildroot} install
cp -vf ./XATICA/lib/libXATICA.so.3.0 %{buildroot}%{_libdir}/

cp -p %{SOURCE1} %{buildroot}%{_javadir}/
cp -p %{SOURCE2} %{buildroot}%{_javadir}/
cp -p %{SOURCE3} %{buildroot}%{_javadir}/
cp -p %{SOURCE4} %{buildroot}%{_javadir}/
cp -p %{SOURCE5} %{buildroot}%{_javadir}/
cp -p %{SOURCE6} %{buildroot}%{_javadir}/
#cp %{SOURCE7} %{buildroot}%{_javadir}/
cp -p %{SOURCE8} %{buildroot}%{_javadir}/
cp -p %{SOURCE9} %{buildroot}%{_javadir}/
cp -p %{SOURCE10} %{buildroot}%{_javadir}/
cp -p %{SOURCE11} %{buildroot}%{_javadir}/
cp -p %{SOURCE12} %{buildroot}%{_javadir}/
cp -p %{SOURCE13} %{buildroot}%{_javadir}/
cp -p %{SOURCE24} %{buildroot}%{_javadir}/
cp -p %{SOURCE25} %{buildroot}%{_javadir}/
cp -p %{SOURCE23} %{buildroot}%{_javadir}/


%{__mkdir_p} %{buildroot}%{dixidir}/libs
cd %{buildroot}%{_javadir}
#for file in *.jar
#do
#  ;{__ln_s} "%{_javadir}/$file" "%{buildroot}%{dixidir}/libs/$file"
#done

# add links to required .jars
for file in bcprov.jar velocity.jar sunxacml.jar srds.jar oncrpc.jar \
	    jrpcgen.jar xstream.jar xpp3.jar \
	    commons-cli.jar ws-commons-util.jar servlet.jar
do 
  %{__ln_s} "%{_javadir}/$file" "%{buildroot}%{dixidir}/libs/$file"
done
%{__ln_s} %{_javadir}/scalaris/scalaris.jar %{buildroot}%{dixidir}/libs/scalaris.jar

cd -


pushd %{buildroot}%{_javadir}
ln -sf axis2-kernel-1.2.jar axis2-kernel.jar
ln -sf mina-core-1.1.5.jar mina-core.jar
ln -sf mina-filter-ssl-1.1.5.jar mina-filter-ssl.jar
ln -sf velocity-dep-1.5.jar velocity-dep.jar
ln -sf slf4j-api-1.5.0.jar slf4j-api.jar
ln -sf slf4j-simple-1.5.0.jar slf4j-simple.jar
ln -sf axis2-kernel-1.3.jar axis2-kernel.jar
ln -sf cloning-1.4.jar cloning.jar
ln -sf vivaldi-1.1.jar vivaldi.jar
ln -s objenesis-1.1.jar objenesis.jar
#ln -sf log4j-over-slf4j-1.5.0.jar log4j-over-slf4j.jar
popd

%create_jar_links

%clean
rm -rf $RPM_BUILD_ROOT

%post
%{__mkdir_p} %{_sysconfdir}/xos/config
ln -sf %{_javadir}/log4j.jar %{dixidir}/libs/log4j.jar
%_post_service xosd
%_post_service jsdl-exec

%preun
%_preun_service xosd
%_preun_service jsdl-exec

%files
%doc README.txt DIXI.txt AUTHORS.txt INSTALL.txt QUICKSTART.txt
%defattr(-,root,root)
%{_bindir}/dixi-junit-test
%{_bindir}/rca_node_descriptor
%{_bindir}/rca_resource_vo
#%{_libdir}/*.so*

%{_javadir}/DIXIMain.jar
%{_javadir}/DIXIMain-%{version}.jar
%{_initrddir}/xosd
%{dixidir}/libs/*.jar
%config(noreplace) %{_initrddir}/jsdl-exec
%config(noreplace) %{xosconfigdir}/acl.conf
%config(noreplace) %{xosconfigdir}/XOSdConfig.conf
%{_sysconfdir}/xos/truststore/certs
%{_sysconfdir}/xos/truststore/private
%{dixidir}/dixi_run.sh
%{dixidir}/kill_dixi.sh
%{dixidir}/killtree.sh
%{dixidir}/log4j.properties
%{dixidir}/log4j_xati.properties
%{_bindir}/build-dixi-classpath-directory
%{dixidir}/dixi-main.deps
%{dixidir}/srds.deps
%{dixidir}/supplement.deps
%{dixidir}/scalaris.deps
%{dixidir}/srds-other.deps

%files -n dixi-services
%defattr(-,root,root)
%{_javadir}/DIXIMainServices.jar
%{_javadir}/DIXIMainServices-%{version}.jar
%{dixidir}/XMLExtractor/files
%{dixidir}/XMLExtractor/Schemas/access_control-xacml-2.0-policy-schema-os.xsd
%{dixidir}/XMLExtractor/Schemas/container.xsd
%{dixidir}/XMLExtractor/Schemas/cs-xacml-schema-policy-01.xsd
%{dixidir}/XMLExtractor/Schemas/document.xsd
%{dixidir}/XMLExtractor/Schemas/GLUESchema12.xsd
%{dixidir}/XMLExtractor/Schemas/GLUESchema12R2.xsd
%{dixidir}/XMLExtractor/Schemas/jsdl.xsd
%{dixidir}/XMLExtractor/Schemas/jsdl-sdl.xsd
%{dixidir}/XMLExtractor/Schemas/jsdl-posix.xsd
%{dixidir}/XMLExtractor/Schemas/jsdl-xos.xsd
%{dixidir}/XMLExtractor/Schemas/network-jsdl-1-0-ext.xsd
%config(noreplace) %{xosdstagesdir}/CronDaemon.stage
%config(noreplace) %{xosdstagesdir}/DaemonGlobal.stage
%config(noreplace) %{xosdstagesdir}/XMLExtractor.stage

%files -n dixi-xati
%defattr(-,root,root)
%{dixidir}/tests/testSRDSMng.sh
%{dixidir}/xtest.sh
%{dixidir}/XMLExtractor/Schemas/JobInfoList.xsd
%{dixidir}/XMLExtractor/Schemas/MetricsDesc.xsd
%{_javadir}/xati.jar
%{_javadir}/xati-%{version}.jar
%{_bindir}/add_resource_to_vo
%{_bindir}/dixi_diag
%{_bindir}/dixi_test
%{_bindir}/rca_apply
%{_bindir}/rca_confirm
%{_bindir}/rca_info
%{_bindir}/rca_primary
%{_bindir}/rca_list_pending
%{_bindir}/rca_list_registered
%{_bindir}/rca_remove
%{_bindir}/rca_request
%{_bindir}/rca_unregister
%{_bindir}/rca_update
%{_bindir}/rca_vo
%{_bindir}/request_vo_certificate
%{_bindir}/validate-xml
%{_bindir}/vops
%{_bindir}/xaudit
%{_bindir}/xconsole_dixi
%{_bindir}/xmon
%{_bindir}/xosd
%{_bindir}/xosd_profile
%{_bindir}/xosdkill
%{_bindir}/xreservation
%{dixidir}/dixi-xati.deps


%files -n dixi-cxati
%defattr(-,root,root)
%{_bindir}/XOSExec
%{_bindir}/XOSJobDaemon
%{_bindir}/xjob
%{_bindir}/xjobKill
%{_bindir}/xps
%{_bindir}/xsub
%{_bindir}/xsub.sh
%{_bindir}/xsubMPI
%{_bindir}/xsubwrapper
%{_bindir}/xtrace
%{_bindir}/xwait
%{_libdir}/libXATICA.so*
%{dixidir}/bin/mpirun.*
%{dixidir}/bin/XOS_mpirun

%files jardeps
%defattr(-,root,root)
%{_javadir}/axis2-kernel-1.2.jar
%{_javadir}/mina-core-1.1.5.jar
%{_javadir}/mina-core.jar
%{_javadir}/mina-filter-ssl-1.1.5.jar
%{_javadir}/mina-filter-ssl.jar
%{_javadir}/velocity-dep-1.5.jar
%{_javadir}/velocity-dep.jar
%{_javadir}/slf4j-api-1.5.0.jar
%{_javadir}/slf4j-api.jar
%{_javadir}/slf4j-simple-1.5.0.jar
%{_javadir}/slf4j-simple.jar
%{_javadir}/axis2-kernel-1.3.jar
%{_javadir}/axis2-kernel.jar
%{_javadir}/cloning-1.4.jar
%{_javadir}/cloning.jar
%{_javadir}/exist.jar
%{_javadir}/vivaldi-1.1.jar
%{_javadir}/vivaldi.jar
%{_javadir}/objenesis-1.1.jar
%{_javadir}/objenesis.jar
%{_javadir}/xmldb-svn.jar
%{_javadir}/xmlrpc-client-3.1.2.jar
%{_javadir}/xmlrpc-common-3.1.2.jar
%{_javadir}/xmlrpc-server-3.1.2.jar


%files -n dixi-devel
%{_includedir}/*.h
%{dixidir}/lib/libXATICA.a

%files javadoc
%defattr(-,root,root)
%doc Support/Documentation

%files -n dixi-client
%defattr(-,root,root)
%doc README.txt DIXI.txt AUTHORS.txt INSTALL.txt QUICKSTART.txt

%files -n dixi-core
%defattr(-,root,root)
%doc README.txt DIXI.txt AUTHORS.txt INSTALL.txt QUICKSTART.txt

%files -n dixi-node
%defattr(-,root,root)
%doc README.txt DIXI.txt AUTHORS.txt INSTALL.txt QUICKSTART.txt

